{ Version 2.0 }
unit PicView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls, Buttons, Parser, Menus,
  IniFiles, ClipBrd, PicTune, ExeImage, rxTypes, ClipIcon, Progress;

type
  TPicViewForm = class(TForm)
    pnDir: TPanel;
    Panel2: TPanel;
    pnControl: TPanel;
    DirBox: TDirectoryListBox;
    pgMain: TPageControl;
    tsIco: TTabSheet;
    tsGlyphs: TTabSheet;
    Group: TScrollBox;
    Splitter1: TSplitter;
    IcoFiles: TFileListBox;
    CurFiles: TFileListBox;
    IcoBox: TScrollBox;
    pnEdit: TPanel;
    pnRight: TPanel;
    pnExample: TPanel;
    pnButtons: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    pnBackDrive: TPanel;
    pnLeftDrive: TPanel;
    pnRightDrive: TPanel;
    Panel13: TPanel;
    DriveBox: TScrollBox;
    pnDrives: TPanel;
    Drives: TDriveComboBox;
    PrevBtn: TSpeedButton;
    NextBtn: TSpeedButton;
    tsPicture: TTabSheet;
    ExampleBtn: TSpeedButton;
    BmpFiles: TFileListBox;
    Popup: TPopupMenu;
    pnPic: TPanel;
    pnImage: TPanel;
    edName: TEdit;
    lbEdit: TLabel;
    ExampleImage: TImage;
    Panel8: TPanel;
    rgPic: TRadioGroup;
    ScrollBox: TScrollBox;
    Image1: TImage;
    SpeedBar: TPanel;
    SaveDirBtn: TSpeedButton;
    TuneBtn: TSpeedButton;
    tsResource: TTabSheet;
    Panel3: TPanel;
    Label1: TLabel;
    cbFile: TComboBox;
    ResIcoBtn: TSpeedButton;
    ResBmpBtn: TSpeedButton;
    ExeFiles: TFileListBox;
    ResLstBtn: TSpeedButton;
    ResNote: TNotebook;
    sbRes: TScrollBox;
    Splitter2: TSplitter;
    TreeView: TTreeView;
    Splitter3: TSplitter;
    Panel4: TPanel;
    Panel5: TPanel;
    ScrollBox1: TScrollBox;
    ResImage: TImage;
    Panel6: TPanel;
    rgResPic: TRadioGroup;
    ilSmall: TImageList;
    SaveBtn: TSpeedButton;
    SaveDlg: TSaveDialog;
    CopyBtn: TSpeedButton;
    PasteBtn: TSpeedButton;
    SaveToDirBtn: TSpeedButton;
    tsScreen: TTabSheet;
    sbScreen: TScrollBox;
    ScreenImage: TImage;
    Panel7: TPanel;
    ZoomInBtn: TSpeedButton;
    ZoomOutBtn: TSpeedButton;
    GetScreenBtn: TSpeedButton;
    pnZoom: TPanel;
    procedure DirBoxChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pnDirResize(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure PopupPopup(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SaveDirBtnClick(Sender: TObject);
    procedure pgMainChange(Sender: TObject);
    procedure NextBtnClick(Sender: TObject);
    procedure PrevBtnClick(Sender: TObject);
    procedure ExampleBtnClick(Sender: TObject);
    procedure edNameChange(Sender: TObject);
    procedure BmpFilesChange(Sender: TObject);
    procedure rgPicClick(Sender: TObject);
    procedure ExampleImageClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure TuneBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cbFileChange(Sender: TObject);
    procedure tsResourceEnter(Sender: TObject);
    procedure ResIcoBtnClick(Sender: TObject);
    procedure ResBmpBtnClick(Sender: TObject);
    procedure ResLstBtnClick(Sender: TObject);
    procedure rgResPicClick(Sender: TObject);
    procedure TreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure SaveBtnClick(Sender: TObject);
    procedure CopyBtnClick(Sender: TObject);
    procedure PasteBtnClick(Sender: TObject);
    procedure SaveToDirBtnClick(Sender: TObject);
    procedure GetScreenBtnClick(Sender: TObject);
    procedure ZoomInBtnClick(Sender: TObject);
    procedure ZoomOutBtnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }

    LastDir : String;
    FExeFile: TExeImage;
    ResLst: TList;
    ExcludeBig, ExcludeEmpty: Boolean;
    Zoom: Integer;
    ScrWidth,ScrHeight: Integer;
    LastRect: TRect;
    FocusX,FocusY: Integer;

    { ---- for using in property editor ---- }
    procedure SetPicture(Value: TPicture);
    { -------------------------------------- }
    procedure AlignBut(Group: TScrollBox);
    procedure AlignDrive;
    procedure DriveBtnVisible;
    procedure AlignIco(IcoBox: TScrollBox);
    procedure CalcControlSize;
    procedure DriveClick(Sender : TObject);
    procedure SetDrive(D : Char);
    procedure ItemClick(Sender : TObject);
    procedure ButtonClick(Sender : TObject);
    procedure IcoClick(Sender : TObject);
    procedure SetDir(const Dir: String;ExceptFlag: Boolean);
    procedure LoadState;
    procedure rgPicChange(rgPic: TRadioGroup;Image1: TImage);
    function GetPicture: TPicture;
    procedure CreateBtn(Bmp: TBitmap;S: String;P: TWinControl);
    { --------- Resources --------------- }
    procedure SetResource;
    procedure CreateTree(ResList: TResourceList;Node: TTreeNode);
    procedure CreateIco(ResList: TResourceList);
    procedure CreateBmp(ResList: TResourceList);
    { --------- Screen -------------- }
    procedure SetZoom;
    procedure InitRect;
    procedure DrawFrame(X,Y: Integer);
  public
    { Public declarations }
    Ini : TIniFile;
    BtnWidth,BtnHeight: Integer;
    { property & procedures using in property editor }
    GraphicClass: TGraphicClass;
    Function Open(Glyph: Boolean): TModalResult;
    property Pic: TPicture read GetPicture write SetPicture;
  end;

var
  PicViewForm: TPicViewForm;
const
  DirSect='Directory';

implementation

{$R *.DFM}

function CreatePath(Dir,Name: String): String;
Begin
  Name := ExtractFileName(Name);
  IF Dir[Length(Dir)]<>'\' Then
    Dir := Dir+'\';
  Result := Dir+Name;
End;

function CreateBitmapFromIcon(Icon: TIcon; BackColor: TColor): TBitmap;
{ Copyright by RX }
var
  IWidth, IHeight: Integer;
begin
  IWidth := Icon.Width;
  IHeight := Icon.Height;
  Result := TBitmap.Create;
  try
    Result.Width := IWidth;
    Result.Height := IHeight;
    with Result.Canvas do begin
      Brush.Color := BackColor;
      FillRect(Rect(0, 0, IWidth, IHeight));
      Draw(0, 0, Icon);
    end;
  except
    Result.Free;
    raise;
  end;
end;

function FirstCompare(Str,SubStr : String) : Boolean;
var
  i : Integer;
Begin
  Result := False;
  IF Length(SubStr)>Length(Str) Then Exit;
  For i := 1 to Length(SubStr) do
    IF CaseUp(SubStr[i])<>CaseUp(Str[i]) Then Exit;
  Result := True;
End;

procedure TPicViewForm.DirBoxChange(Sender: TObject);
var
  SB : TSpeedButton;
  i : Integer;
  Ico : TIcon;
  Image : TImage;
  Bmp: TBitmap;
begin
  { -----------  --------- }
  While Group.ControlCount>0 do
  begin
    SB := Group.Controls[0] as TSpeedButton;
    SB.Free;
  end;

  InitProgress(BmpFiles.Items.Count-1+IcoFiles.Items.Count-1);

  Bmp := TBitmap.Create;
  For i := 0 to BmpFiles.Items.Count-1 do
  begin
    try
      Bmp.LoadFromFile(CreatePath(BmpFiles.Directory,BmpFiles.Items[i]));
    except
      Continue;
    end;
    NextStep;
    CreateBtn(Bmp,BmpFiles.Items[i],Group);
  end;
  Bmp.Free;
  AlignBut(Group);

  { ---------------  ------------- }
  IcoFiles.Directory := DirBox.Directory;
  While IcoBox.ControlCount>0 do
    IcoBox.Controls[0].Free;

  For i := 0 to IcoFiles.Items.Count-1 do
  begin
    Ico := TIcon.Create;
    try
      Ico.LoadFromFile(IcoFiles.Directory+'\'+IcoFiles.Items[i]);
    except
      Ico.Free;
      Continue;
    end;
    NextStep;
    Image := TImage.Create(Self);
    Image.Parent := IcoBox;
    Image.Picture.Graphic := Ico;
    Image.Hint := IcoFiles.Items[i];
    Image.AutoSize := True;
    Image.OnClick := IcoClick;
  end;
  AlignIco(IcoBox);
  CloseProgress;

  { ---------------  ------------- }
  ExeFiles.Directory := DirBox.Directory;
  IF pgMain.ActivePage = tsResource Then
    SetResource;
end;

Procedure TPicViewForm.AlignBut(Group: TScrollBox);
var
  SB : TSpeedButton;
  i : Integer;
  NumBut : Integer;
  Dx,Dy: Integer;
  Fl: Boolean;
Begin
  Dx := BtnWidth+10;
  Dy := BtnHeight+10;
  Group.Visible := False;
  Group.VertScrollBar.Position := 0;
  Group.HorzScrollBar.Position := 0;
  NumBut := Group.Width div Dx;
  Fl := ViewProgress;
  IF not Fl Then
    InitProgress(Group.ControlCount-1);
  For i := 0 to Group.ControlCount-1 do
  begin
    SB := Group.Controls[i] as TSpeedButton;
    SB.Left := (i mod NumBut)*Dx+5;
    SB.Width := BtnWidth;
    SB.Top := (i div NumBut)*Dy+5;
    SB.Height := BtnHeight;
    IF not Fl Then
      NextStep;
  end;
  IF not Fl Then
    CloseProgress;
  Group.Visible := True;
End;

Procedure TPicViewForm.AlignIco(IcoBox: TScrollBox);
var
  Image : TImage;
  i : Integer;
  NumIco : Integer;
  Fl: Boolean;
Begin
  IcoBox.Visible := False;
  IcoBox.VertScrollBar.Position := 0;
  IcoBox.HorzScrollBar.Position := 0;
  NumIco := IcoBox.Width div 35;
  Fl := ViewProgress;
  IF not Fl Then
    InitProgress(IcoBox.ControlCount-1);
  For i := 0 to IcoBox.ControlCount-1 do
  begin
    Image := IcoBox.Controls[i] as TImage;
    Image.Left := (i mod NumIco)*35+5;
    Image.Top := (i div NumIco)*35+5;
    IF not Fl Then
      NextStep;
  end;
  IF not Fl Then
    CloseProgress;
  IcoBox.Visible := True;
End;

procedure TPicViewForm.FormResize(Sender: TObject);
begin
  AlignBut(Group);
end;

procedure TPicViewForm.FormCreate(Sender: TObject);
var
  SB : TSpeedButton;
  i : Integer;
  S : String;
begin
  FExeFile := Nil;
  ResLst := TList.Create;
  LastDir := GetCurrentDir;
  For i := 0 to Drives.Items.Count-1 do
  begin
    SB := TSpeedButton.Create(Self);
    With SB do
    begin
      Parent := pnDrives;
      S := Drives.Items[i];
      Caption := S[1];
      Hint := GetWord(S,2,['[',']']);
      GroupIndex := 1;
      Font.Style := [fsBold];
      Font.Color := clNavy;
      OnClick := DriveClick;
    end;
  end;

  SetDrive(DirBox.Drive);
  AlignDrive;
  Ini := TIniFile.Create('PicView.Ini');
  SetDir(Ini.ReadString('Config','LastDir',LastDir),False);
  LoadState;

  DirBoxChange(Nil);
  pgMainChange(Nil);

end;

procedure TPicViewForm.DriveClick(Sender : TObject);
Begin
  try
    DirBox.Drive := (Sender as TSpeedButton).Caption[1];
  except
    MessageDlg('  ',mtError,[mbOK],0);
    SetDrive(DirBox.Drive);
  end;
End;

procedure TPicViewForm.SetDrive(D : Char);
var
  i : Integer;
  SB : TSpeedButton;
Begin
  For i := 0 to pnDrives.ControlCount-1 do
  begin
    IF pnDrives.Controls[i] is TSpeedButton Then
    begin
      SB := pnDrives.Controls[i] as TSpeedButton;
      IF Sb.Caption[1]=D Then
      begin
        Sb.Down := True;
        Exit;
      end;
    end;
  end;
End;

Procedure TPicViewForm.AlignDrive;
var
  i : Integer;
  W : Integer;
  SB : TSpeedButton;
Begin
  IF 26*Drives.Items.Count>=pnBackDrive.Width Then
  begin
    pnLeftDrive.Visible := True;
    pnRightDrive.Visible := True;
    pnDrives.Width := 26*Drives.Items.Count;
    DriveBox.HorzScrollBar.Range := pnDrives.Width;
    DriveBox.Height := pnDrives.Height+50;
  end
  Else
  begin
    pnLeftDrive.Visible := False;
    pnRightDrive.Visible := False;
    pnDrives.Width := DriveBox.Width;
    DriveBox.Height := pnDrives.Height+20;
  end;
  W := pnDrives.Width div Drives.Items.Count;
  For i := 0 to pnDrives.ControlCount-1 do
  begin
    IF pnDrives.Controls[i] is TSpeedButton Then
    begin
      SB := pnDrives.Controls[i] as TSpeedButton;
      SB.Left := W*i+W div 2 -12;
      SB.Top := 1;
    end;
  end;
  DriveBtnVisible;
End;

procedure TPicViewForm.pnDirResize(Sender: TObject);
begin
  AlignDrive;
end;

procedure TPicViewForm.Panel2Resize(Sender: TObject);
begin
  AlignBut(Group);
  AlignIco(IcoBox);
  IF ResBmpBtn.Down Then
    AlignBut(sbRes);
  IF ResIcoBtn.Down Then
    AlignIco(sbRes);
end;

procedure TPicViewForm.PopupPopup(Sender: TObject);
var
  Str : TStrings;
  i : Integer;
  Item : TMenuItem;
begin
  Str := TStringList.Create;
  Ini.ReadSectionValues(DirSect,Str);
  While PopUp.Items.Count>0 do
    PopUp.Items.Delete(0);
  For i := 0 to Str.Count-1 do
  begin
    Item := TMenuItem.Create(Popup);
    Item.Caption := GetWord(Str[i],2,['=']);
    Item.OnClick := ItemClick;
    Popup.Items.Insert(0,Item);
  end;
  Str.Free;
end;

procedure TPicViewForm.FormDestroy(Sender: TObject);
begin
  ResLst.Free;
  Ini.WriteString('Config','LastDir',DirBox.Directory);
  Ini.WriteInteger('Config','rgResPic',rgResPic.ItemIndex);
  Ini.WriteInteger('Config','rgPic',rgPic.ItemIndex);
  Ini.WriteInteger('Config','Zoom',Zoom);
  SetCurrentDir(LastDir);
  Ini.Free;
  IF Assigned(ProgressDlg) Then
  begin
    ProgressDlg.Free;
    ProgressDlg := Nil;
  end;
end;

procedure TPicViewForm.SaveDirBtnClick(Sender: TObject);
var
  Str : TStrings;
  i : Integer;
begin
  Str := TStringList.Create;
  Ini.ReadSectionValues(DirSect,Str);
  For i := 0 to Str.Count-1 do
    Str[i] := GetWord(Str[i],2,['=']);
  For i := 0 to Str.Count-1 do
    IF Str[i]=DirBox.Directory Then Exit;
  Str.Add(DirBox.Directory);
  Ini.EraseSection(DirSect);
  For i := 0 to Str.Count-1 do
    Ini.WriteString(DirSect,IntToStr(i),Str[i]);
  Str.Free;
end;

Procedure TPicViewForm.SetDir(const Dir: String;ExceptFlag: Boolean);
Begin
  try
    DirBox.Directory := Dir;
    SetDrive(DirBox.Drive);
  except
    IF ExceptFlag Then
      MessageDlg('  !',mtError,[mbOK],0);
  end;

End;

Procedure TPicViewForm.ItemClick(Sender : TObject);
Begin
  SetDir((Sender as TMenuItem).Caption,True);
End;

procedure TPicViewForm.pgMainChange(Sender: TObject);
var
  i : Integer;
begin
  Panel2Resize(Nil);
  For i := 0 to pnExample.ControlCount-1 do
    pnExample.Controls[i].Visible := False;
  Case pgMain.ActivePage.Tag of
    0: ExampleImage.Visible := True;
    1: ExampleBtn.Visible := True;
  End; // Case
  pnDir.Visible := pgMain.ActivePage<>tsScreen;
end;

procedure TPicViewForm.ButtonClick(Sender : TObject);
var
  SB : TSpeedButton;
Begin
  SB := Sender as TSpeedButton;
  ExampleBtn.Glyph.Assign(SB.Glyph);
  ExampleBtn.Hint := SB.Hint;
  ExampleBtn.NumGlyphs := SB.NumGlyphs;
  SB.Down := True;
End;

procedure TPicViewForm.IcoClick(Sender : TObject);
var
  Ico : TImage;
Begin
  Ico := Sender as TImage;
  ExampleImage.Picture.Assign(Ico.Picture);
  ExampleImage.Hint := Ico.Hint; 
End;

procedure TPicViewForm.NextBtnClick(Sender: TObject);
begin
  With DriveBox.HorzScrollBar do
    Position := Position+26;
  DriveBtnVisible;
end;


procedure TPicViewForm.PrevBtnClick(Sender: TObject);
begin
  With DriveBox.HorzScrollBar do
    Position := Position-26;
  DriveBtnVisible;
end;

Procedure TPicViewForm.DriveBtnVisible;
Begin
  With DriveBox.HorzScrollBar do
  begin
    PrevBtn.Enabled := Position >2;
    NextBtn.Enabled := Position <Range-DriveBox.Width-2 ;
  end;
End;

procedure TPicViewForm.ExampleBtnClick(Sender: TObject);
begin
  Clipboard.Assign(ExampleBtn.Glyph);
end;

procedure TPicViewForm.edNameChange(Sender: TObject);
var
  i : Integer;
  Ct : TWinControl;
begin
  Ct := Nil;
  Case pgMain.ActivePage.Tag of
    0: Ct := IcoBox;
    1: Ct := Group;
    2:
    begin
      For i := 0 to BmpFiles.Items.Count-1 do
        IF FirstCompare(BmpFiles.Items[i],edName.Text) Then
        begin
          BmpFiles.ItemIndex := i;
          Exit;
        end;
    end;
  End;

  IF Ct=Nil Then Exit;
  For i := 0 to Ct.ControlCount-1 do
    IF FirstCompare(Ct.Controls[i].Hint,edName.Text) Then
    begin
      Case pgMain.ActivePage.Tag of
        0: IcoClick(Ct.Controls[i]);
        1: ButtonClick(Ct.Controls[i]);
      End;
      Exit;
    end;
end;

procedure TPicViewForm.BmpFilesChange(Sender: TObject);
begin
  try
    Image1.Picture.LoadFromFile(BmpFiles.FileName);
  except
  end;
end;

procedure TPicViewForm.rgPicChange(rgPic: TRadioGroup;Image1: TImage);
begin
  IF rgPic.ItemIndex=2 Then
  begin
    Image1.Align := alNone;
    Image1.AutoSize := True;
  end
  Else
  begin
    Image1.AutoSize := False;
    Image1.Align := alClient;
  end;
  Image1.Stretch := rgPic.ItemIndex=0;
  Image1.Center := rgPic.ItemIndex=1;
end;

procedure TPicViewForm.rgPicClick(Sender: TObject);
Begin
  rgPicChange(rgPic,Image1);
End;

procedure TPicViewForm.ExampleImageClick(Sender: TObject);
begin
  Clipboard.Assign(ExampleImage.Picture);
end;

Function TPicViewForm.GetPicture: TPicture;
Begin
  Case pgMain.ActivePage.Tag of
    0: Result := ExampleImage.Picture;
    1:
    begin
      ExampleImage.Picture.Assign(ExampleBtn.Glyph);
      Result := ExampleImage.Picture;
    end;
    2: Result := Image1.Picture;
    3:
    begin
      IF ResBmpBtn.Down Then
        ExampleImage.Picture.Assign(ExampleBtn.Glyph);
      IF ResLstBtn.Down Then
        Result := ResImage.Picture
      Else
        Result := ExampleImage.Picture;
    end;
  End; // Case
End;

Function TPicViewForm.Open(Glyph: Boolean): TModalResult;
var
  Bmp: TBitmap;
  P: TPicture;
Begin
  tsGlyphs.TabVisible := (GraphicClass=TGraphic) or (GraphicClass=TBitmap);
  tsPicture.TabVisible := (GraphicClass=TGraphic) or (GraphicClass=TBitmap);
  IF GraphicClass=TIcon Then
    pgMain.ActivePage := tsIco
  Else IF Glyph Then
    pgMain.ActivePage := tsGlyphs
  Else
    pgMain.ActivePage := tsPicture;

  IF Glyph and (not Ini.ReadBool('Config','PropEdit',True)) Then
  begin
    BtnWidth := Ini.ReadInteger('Config','Width',25);
    BtnHeight := Ini.ReadInteger('Config','Height',25);
  end;

  CalcControlSize;

  pgMainChange(Nil);
  Result := ShowModal;
  IF Result=mrOK Then
  begin
    P := GetPicture;
    IF (GraphicClass=TBitmap) and (P.Graphic is TIcon) Then
    begin
      Bmp := CreateBitmapFromIcon(P.Graphic as TIcon,clBtnFace);
      ExampleImage.Picture.Assign(Bmp);
      ExampleBtn.Glyph.Assign(Bmp);
      Bmp.Free;
    end;
  end;
End;

procedure TPicViewForm.Image1Click(Sender: TObject);
begin
  ExampleImage.Picture.Assign(Image1.Picture);
end;

procedure TPicViewForm.CalcControlSize;
  procedure CenterY(C: TControl;Source: TControl);
  begin
    C.Top := Source.Height div 2 - C.Height div 2;
  end; // CenterY
  procedure CenterX(C: TControl;Source: TControl);
  begin
    C.Top := Source.Width div 2 - C.Width div 2;
  end; // CenterY
Begin //CalcControlSize
  DisableAlign;
  ExampleBtn.Width := BtnWidth;
  ExampleBtn.Height := BtnHeight;
  pnControl.Height := BtnHeight+16;
  pnExample.Width := BtnWidth+16;
  pnRight.Width := pnButtons.Width+pnExample.Width;
  EnableAlign;
  CenterY(ExampleBtn,pnExample);CenterX(ExampleBtn,pnExample);
  CenterY(ExampleImage,pnExample);CenterX(ExampleImage,pnExample);
  CenterY(OkBtn,pnButtons);
  CenterY(CancelBtn,pnButtons);
  CenterY(edName,pnEdit);
  CenterY(lbEdit,pnEdit);
End;

procedure TPicViewForm.LoadState;
Begin
  BtnWidth := Ini.ReadInteger('Config','Width',25);
  BtnHeight := Ini.ReadInteger('Config','Height',25);
  rgResPic.ItemIndex := Ini.ReadInteger('Config','rgResPic',1);
  rgPic.ItemIndex := Ini.ReadInteger('Config','rgPic',0);
  ExeFiles.Mask := Ini.ReadString('Config','ExeFiles','*.Exe;*.Dll;*.Dpl');
  ExcludeBig := Ini.ReadBool('Config','BigImage',True);
  ExcludeEmpty := Ini.ReadBool('Config','EmptyImage',True);
  Zoom := Ini.ReadInteger('Config','Zoom',1);
  pnZoom.Caption := 'x'+IntToStr(Zoom);
  CalcControlSize;
End;

procedure TPicViewForm.TuneBtnClick(Sender: TObject);
begin
  Application.CreateForm(TTuneDlg,TuneDlg);
  TuneDlg.Form := Self;
  IF TuneDlg.Open=mrOK Then
    LoadState;
  TuneDlg.Free;
end;

procedure TPicViewForm.FormShow(Sender: TObject);
begin
  CalcControlSize;
end;

procedure TPicViewForm.CreateTree(ResList: TResourceList; Node: TTreeNode);
const
  ImageMap: array[TResourceType] of Byte = (2,4,5,3,2,2,2,2,2,2,2,2,2,2,2,2,2);
var
  i: Integer;
  CNode: TTreeNode;
begin
  For i := 0 to ResList.Count - 1 do
    With ResList[i] do
    begin
      IF (not (ResType in [rtBitmap,rtIconEntry,rtIcon])) and
        (not IsList) Then
        Continue;
      CNode := TreeView.Items.AddChildObject(Node, Name, ResList[I]);
      IF IsList Then
      begin
        CNode.SelectedIndex := 1;
        CreateTree(List, CNode);
      end
      Else
      begin
        CNode.ImageIndex := ImageMap[ResList[i].ResType];
        CNode.SelectedIndex := CNode.ImageIndex;
        ResLst.Add(ResList[i]);
      end;
    end; // With
end;

procedure TPicViewForm.SetResource;
Begin
  While sbRes.ControlCount>0 do
    sbRes.Controls[0].Free;
  IF Assigned(FExeFile) Then
    FExeFile.Destroy;
  ResLst.Clear;
  TreeView.OnChange := Nil;
  TreeView.Items.Clear;
  TreeView.OnChange := TreeViewChange;
  try
    FExeFile := TExeImage.CreateImage(Self, cbFile.Text);
  except
    FExeFile := Nil;
    cbFile.Text := '';
    Exit;
  end;
  CreateTree(FExeFile.Resources, nil);
  IF ResIcoBtn.Down Then
    CreateIco(FExeFile.Resources);
  IF ResBmpBtn.Down Then
    CreateBmp(FExeFile.Resources);
End;

procedure TPicViewForm.CreateIco(ResList: TResourceList);
var
  i: Integer;
  Image: TImage;
  R: TResourceItem;
Begin
  While sbRes.ControlCount>0 do
    sbRes.Controls[0].Free;
  InitProgress(ResLst.Count-1);
  For i := 0 to ResLst.Count-1 do
  begin
    R := ResLst[i];
    NextStep;
    IF R.ResType<>rtIconEntry Then Continue;
    Image := TImage.Create(Self);
    Image.Parent := sbRes;
    Image.Picture.Assign(R);
    Image.Hint := R.Name;
    Image.AutoSize := True;
    Image.OnClick := IcoClick;
  end;
  CloseProgress;
  AlignIco(sbRes);
End;

procedure TPicViewForm.CreateBmp(ResList: TResourceList);
var
  SB: TSpeedButton;
  i: Integer;
  R: TResourceItem;
  Image: TImage;
Begin
  While sbRes.ControlCount>0 do
    sbRes.Controls[0].Free;
  Image := TImage.Create(Self);
  InitProgress(ResLst.Count-1);
  For i := 0 to ResLst.Count-1 do
  begin
    R := ResLst[i];
    NextStep;
    IF R.ResType<>rtBitmap Then Continue;
    Image.Picture.Assign(R);
    CreateBtn(Image.Picture.Bitmap,R.Name,sbRes);
  end;
  Image.Free;
  CloseProgress;
  AlignBut(sbRes);
End;

procedure TPicViewForm.cbFileChange(Sender: TObject);
begin
  SetResource;
end;

procedure TPicViewForm.tsResourceEnter(Sender: TObject);
begin
  cbFile.Items.Assign(ExeFiles.Items);
end;

procedure TPicViewForm.ResIcoBtnClick(Sender: TObject);
begin
  ResNote.PageIndex := 0;
  ExampleBtn.Visible := False;
  ExampleImage.Visible := True;
  IF Assigned(FExeFile) Then
    CreateIco(FExeFile.Resources);
end;

procedure TPicViewForm.ResBmpBtnClick(Sender: TObject);
begin
  ResNote.PageIndex := 0;
  ExampleBtn.Visible := True;
  ExampleImage.Visible := False;
  IF Assigned(FExeFile) Then
    CreateBmp(FExeFile.Resources);
end;

procedure TPicViewForm.ResLstBtnClick(Sender: TObject);
begin
  ResNote.PageIndex := 1;
  ExampleBtn.Visible := False;
  ExampleImage.Visible := True;
end;

procedure TPicViewForm.rgResPicClick(Sender: TObject);
begin
  rgPicChange(rgResPic,ResImage);
end;

procedure TPicViewForm.TreeViewChange(Sender: TObject; Node: TTreeNode);
var
  R: TResourceItem;
begin
  With TreeView do
  begin
    IF (not Visible) or (not Assigned(Selected)) Then Exit;
    R := TResourceItem(Selected.Data);
    IF R.ResType in [rtBitmap, rtIconEntry] Then
      ResImage.Picture.Assign(R)
    Else
      ResImage.Picture.Graphic := Nil;
  end;
end;


procedure TPicViewForm.SaveBtnClick(Sender: TObject);
const
  Filter : Array[1..3] of String=(
    'Bitmap files (*.bmp)|*.bmp|',
    'Icon files (*.ico)|*.ico|',
    'Any files (*.*)|*.*');
var
  Ext: String;
  Pic: TPicture;
  function CreateFileName: String;
  begin
    Result := SaveDlg.FileName;
    IF Ext='' Then
    begin
      IF SaveDlg.FilterIndex=1 Then
        Result := Result+'.Bmp'
      Else IF (SaveDlg.FilterIndex=2) and (Pic.Graphic is TIcon) Then
        Result := Result+'.Ico';
    end;
  end; // CreateFileName
  procedure SaveAsBmp;
  var
    Bmp: TBitmap;
  begin
    IF Pic.Graphic is TBitmap Then
      Pic.SaveToFile(CreateFileName)
    Else
    begin
      Bmp := CreateBitmapFromIcon(Pic.Graphic as TIcon,
        Ini.ReadInteger('Config','BackColor',clBlack));
      Bmp.SaveToFile(CreateFileName);
      Bmp.Free;
    end;
  end; // SaveAsBmp
begin // SaveBtnClick
  Pic := GetPicture;
  IF Pic.Graphic is TIcon Then
    SaveDlg.Filter := Filter[1]+Filter[2]+Filter[3]
  Else
    SaveDlg.Filter := Filter[1]+Filter[3];
  IF SaveDlg.Execute Then
  begin
    Ext := UpperCase(ExtractFileExt(SaveDlg.FileName));
    IF (Ext='ICO') or ((Ext<>'BMP') and (SaveDlg.FilterIndex=2)) Then
      Pic.SaveToFile(CreateFileName)
    Else
      SaveAsBmp;
  end;
end;

procedure TPicViewForm.CopyBtnClick(Sender: TObject);
var
  Pic: TPicture;
begin
  Pic := GetPicture;
  IF Pic.Graphic is TIcon Then
    CopyIconToClipboard(TIcon(Pic.Graphic),
    Ini.ReadInteger('Config','BackColor',clBlack))
  Else
    Clipboard.Assign(Pic);
end;

procedure TPicViewForm.CreateBtn(Bmp: TBitmap;S: String;P: TWinControl);
var
  SB: TSpeedButton;
  Count: Integer;
  i: Integer;
  W: Integer;
  function AnalizeEmpty(Bmp: TBitmap): Boolean;
  var
    i,j: Integer;
    C: TColor;
    n: Integer;
  begin
    n := 0;
    With Bmp.Canvas,Bmp do
    begin
      C := Pixels[0,0];
      For i := 0 to Width-1 do
        For j := 0 to Height-1 do
          IF Pixels[i,j]<>C Then
            Inc(n);
    end;
    Result := n<3;
  end; // AnalizeEmpty
  function AnalizeBig(Bmp: TBitmap): Boolean;
  var
    Num: Integer;
  begin
    IF (Bmp.Width mod Bmp.Height=0) Then
      Num :=  Bmp.Width div Bmp.Height
    Else
      Num := 1;
    Result := (Bmp.Height>BtnHeight-2) or
              (Bmp.Width div Num>BtnWidth-2);
  end;
Begin // CreateBtn
  IF ((Bmp.Width mod Bmp.Height)=0) and ((Bmp.Width div Bmp.Height)>2) Then
    Count := Bmp.Width div Bmp.Height
  Else
    Count := 1;
  W := Bmp.Width div Count;
  For i := 1 to Count do
  begin
    SB := Nil;
    try
      SB := TSpeedButton.Create(Self);
      With SB do
      begin
        Parent := P;
        IF ExcludeBig and {(
          ((Bmp.Width div Count)>BtnWidth-2) or
          (Bmp.Height>BtnHeight-2))}AnalizeBig(Bmp) Then
          raise Exception.Create('Image too big');
        Glyph.Width := Bmp.Width div Count;
        Glyph.Height := Bmp.Height;
        Glyph.Canvas.CopyRect(Rect(0,0,Glyph.Width,Glyph.Height),Bmp.Canvas,
          Rect((i-1)*W,0,i*W,Glyph.Height));
        IF ExcludeEmpty and AnalizeEmpty(Glyph) Then
          raise Exception.Create('Image is empty');
        try
          NumGlyphs := Glyph.Width div Glyph.Height;
        except
          NumGlyphs := 1;
        end;
        Width := BtnWidth;
        Height := BtnHeight;
        IF Count>1 Then
          Hint := S+' ('+IntToStr(i)+')'
        Else
          Hint := S;
        OnClick := ButtonClick;
        GroupIndex := 1;
      end; // With
    except
      SB.Free;
    end;
  end; // For
End;

procedure TPicViewForm.PasteBtnClick(Sender: TObject);
var
  Ico: TIcon;
  Bmp: TBitmap;
begin
  IF Clipboard.HasFormat(CF_ICON) Then
  begin
    try
      Ico := CreateIconFromClipboard;
      IF Ico <> nil Then
      begin
        try
          ExampleImage.Picture.Assign(Ico);
          IF ExampleBtn.Visible Then
          begin
            Bmp := CreateBitmapFromIcon(Ico,clBlack);
            ExampleBtn.Glyph.Assign(Bmp);
            Bmp.Free;
          end;
        finally
          Ico.Free;
        end;
      end;
    except
      raise;
    end;
  end // TIcon
  Else
  begin
    IF Clipboard.HasFormat(CF_PICTURE) Then
    begin
      try
        ExampleImage.Picture.Assign(Clipboard);
        ExampleBtn.Glyph.Assign(ExampleImage.Picture.Bitmap);
      except
        raise;
      end;
    end;
  end;
end;

procedure TPicViewForm.SaveToDirBtnClick(Sender: TObject);
var
  Dir: String;
  i,j: Integer;
  Box: TScrollBox;
  function CreateFileName(S: String): String;
  var
    i: Integer;
  begin
    IF (Box=sbRes) and (Pos(' ',S)>0) Then
      S := Copy(S,1,Pos(' ',S)-1)+'_'+GetWord(S,2,['(',')'])
    Else IF Pos(' ',S)>Pos('.',S) Then
      S := Copy(S,1,Pos('.',S)-1)+'_'+GetWord(S,2,['(',')']);
    IF Pos('.',S)<=0 Then
      S := S+'.Bmp';
    Result := S;
  end; // CreateFileName
begin // SaveToDirBtnClick
  IF not SelectDirectory(Dir,[],0) Then
    Exit;
  IF Dir[Length(Dir)]<>'\' Then
    Dir := Dir+'\';
  IF pgMain.ActivePage=tsIco Then
    Box := IcoBox
  Else IF pgMain.ActivePage=tsGlyphs Then
    Box := Group
  Else IF (pgMain.ActivePage=tsResource) and (not ResLstBtn.Down) Then
    Box := sbRes
  Else
    Exit;
  For i := 0 to Box.ControlCount-1 do
  begin
    IF Box.Controls[i] is TImage Then
      (Box.Controls[i] as TImage).Picture.SaveToFile(Dir+Box.Controls[i].Hint)
    Else IF Box.Controls[i] is TSpeedButton Then
      (Box.Controls[i] as TSpeedButton).Glyph.SaveToFile(
        Dir+CreateFileName(Box.Controls[i].Hint));
  end;
  DirBoxChange(Nil);
end;

procedure TPicViewForm.SetPicture(Value: TPicture);
Begin
  ExampleImage.Picture.Assign(Value);
  IF Value.Graphic is TBitmap Then
    ExampleBtn.Glyph := Value.Graphic as TBitmap;
End;


procedure TPicViewForm.GetScreenBtnClick(Sender: TObject);
begin
  IF Clipboard.HasFormat(CF_PICTURE) Then
    With ScreenImage do
    begin
      try
        AutoSize := True;
        Stretch := False;
        Picture.Assign(Clipboard);
        ScrWidth := Width;
        ScrHeight := Height;
        AutoSize := False;
        Stretch := True;
        SetZoom;
      except
        raise;
      end;
    end;
end;

procedure TPicViewForm.SetZoom;
Begin
  ScreenImage.Width := ScrWidth*Zoom;
  ScreenImage.Height := ScrHeight*Zoom;
  pnZoom.Caption := 'x'+IntToStr(Zoom);
End;

procedure TPicViewForm.ZoomInBtnClick(Sender: TObject);
begin
  Inc(Zoom);
  IF Zoom>9 Then
    ZoomInBtn.Enabled := False;
  IF Zoom>1 Then
    ZoomOutBtn.Enabled := True;
  SetZoom;
end;

procedure TPicViewForm.ZoomOutBtnClick(Sender: TObject);
begin
  Dec(Zoom);
  IF Zoom<2 Then
    ZoomOutBtn.Enabled := False;
  IF Zoom<10 Then
    ZoomInBtn.Enabled := True;
  SetZoom;
end;

procedure TPicViewForm.InitRect;
Begin
  LastRect := Rect(0,0,0,0);
  FocusX := 0;
  FocusY := 0;
End;

procedure TPicViewForm.DrawFrame(X,Y: Integer);
var
  Bmp: TBitmap;
Begin
  IF (X=LastRect.Left) and (Y=LastRect.Right) and (not IsRectEmpty(LastRect)) Then
    Exit;
  IF not IsRectEmpty(LastRect) Then
    ScreenImage.Canvas.DrawFocusRect(LastRect);
  LastRect := Rect(X,Y,X+BtnWidth-2,Y+BtnHeight-2);
  ScreenImage.Canvas.DrawFocusRect(LastRect);
  IF Y*Zoom>sbScreen.VertScrollBar.Position+sbScreen.Height-10-Zoom*BtnHeight Then
    sbScreen.VertScrollBar.Position := Y*Zoom
  Else IF Y*Zoom<sbScreen.VertScrollBar.Position Then
    sbScreen.VertScrollBar.Position := Y*Zoom-sbScreen.Height+10+Zoom*BtnHeight;

  IF X*Zoom>sbScreen.HorzScrollBar.Position+sbScreen.Width-10-Zoom*BtnWidth Then
    sbScreen.HorzScrollBar.Position := X*Zoom
  Else IF X*Zoom<sbScreen.HorzScrollBar.Position Then
    sbScreen.HorzScrollBar.Position := X*Zoom-sbScreen.Width+10+Zoom*BtnWidth;

{  Bmp := TBitmap.Create;
  Bmp.Width := BtnWidth-3;
  Bmp.Height := BtnHeight-3;
  R := LastRect;
  InflateRect(R,-1,-1);
  Bmp.Canvas.CopyRect(
    Rect(0,0,R.Right-R.Left,R.Bottom-R.Top),
    ScreenImage.Canvas,R);
  ExampleBtn.Glyph.Assign(Bmp);
  Bmp.Free;}
  IF (ExampleImage.Picture.Graphic is TIcon) or
    (ExampleImage.Picture.Width<>BtnWidth-2) or
    (ExampleImage.Picture.Height<>BtnHeight-2) Then
  begin
    Bmp := TBitmap.Create;
    Bmp.Width := BtnWidth-2;
    Bmp.Height := BtnHeight-2;
    ExampleImage.Picture.Assign(Bmp);
    Bmp.Free;
  end;
  ExampleImage.Canvas.CopyRect(Rect(0,0,BtnWidth-2,BtnHeight-2),
    ScreenImage.Canvas,LastRect);
End;

procedure TPicViewForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  IF pgMain.ActivePage<>tsScreen Then Exit;
  IF not (ssCtrl in Shift) Then
    Case Key of
      VK_UP: Dec(FocusY);
      VK_DOWN: Inc(FocusY);
      VK_LEFT: Dec(FocusX);
      VK_RIGHT: Inc(FocusX);
      VK_PRIOR: Dec(FocusY,sbScreen.Height-2);
      VK_NEXT: Inc(FocusY,sbScreen.Height-2);
      VK_HOME: Dec(FocusX,sbScreen.Width-2);
      VK_END: Inc(FocusX,sbScreen.Width-2);
    End // Case
  Else
    Case Key of
      VK_UP: Dec(FocusY,BtnHeight-2);
      VK_DOWN: Inc(FocusY,BtnHeight-2);
      VK_LEFT: Dec(FocusX,BtnWidth-2);
      VK_RIGHT: Inc(FocusX,BtnWidth-2);
      VK_PRIOR: FocusY := 0;
      VK_NEXT: FocusY := ScrHeight;
      VK_HOME: FocusX := 0;
      VK_END: FocusX := ScrWidth;
    End; // Case
  IF Key in [VK_UP,VK_DOWN,VK_LEFT,VK_RIGHT,VK_NEXT,VK_PRIOR,VK_HOME,VK_END] Then
    Key := 0;
  IF FocusY<0 Then FocusY := 0;
  IF FocusY>ScrHeight-BtnHeight+2 Then FocusY := ScrHeight-BtnHeight+2;
  IF FocusX<0 Then FocusX := 0;
  IF FocusX>ScrWidth-BtnWidth+2 Then FocusX := ScrWidth-BtnWidth+2;
  DrawFrame(FocusX,FocusY);
end;

end.
