unit Progress;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TProgressDlg = class(TForm)
    Bar: TProgressBar;
    Label1: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ProgressDlg: TProgressDlg;

  procedure InitProgress(Count: Integer);
  procedure NextStep;
  procedure ProgressTo(Value: Integer);
  function ViewProgress: Boolean;
  procedure CloseProgress;

implementation

{$R *.DFM}

procedure InitProgress(Count: Integer);
Begin
  IF not Assigned(ProgressDlg) Then
    ProgressDlg := TProgressDlg.Create(Nil);
  IF ViewProgress or (Count<0) Then Exit;
  ProgressDlg.Bar.Max := Count;
  ProgressDlg.Bar.Position := 0;
  ProgressDlg.Show;
  Screen.Cursor := crHourGlass;
  Application.ProcessMessages;
End;

procedure NextStep;
Begin
  ProgressDlg.Bar.StepIt;
End;

procedure ProgressTo(Value: Integer);
Begin
  ProgressDlg.Bar.Position := Value;
End;

function ViewProgress: Boolean;
Begin
  Result := ProgressDlg.Visible;
End;

procedure CloseProgress;
Begin
  IF ViewProgress Then
  begin
    ProgressDlg.Hide;
    Screen.Cursor := crDefault;
  end;
End;

initialization
  ProgressDlg := Nil;
end.
