{*******************************************************}
{                                                       }
{         Delphi VCL eXtensions   (X)                   }
{                                                       }
{         Copyright (c) 1997 Alexander Buzaev           }
{                                                       }
{*******************************************************}

unit xCommon;

interface
Uses Forms, Registry, Parser, SysUtils, ComCtrls, StdCtrls, Classes;

procedure ReadFormPlacement(fm: TForm; Key: String);
procedure WriteFormPlacement(fm: TForm; Key: String);
procedure ReadFormPosition(fm: TForm; Key: String);
procedure WriteFormPosition(fm: TForm; Key: String);

procedure ReadList(Reg: TRegistry; Ident: String; ls: TStrings);
procedure WriteList(Reg: TRegistry; Ident: String; ls: TStrings);

// ,       
procedure edKeyChar(chKey: Char; ed: TEdit);
procedure cbKeyChar(chKey: Char; cb: TComboBox);

implementation

procedure ReadFormPlacement(fm: TForm; Key: String);
var
  s: String;
Begin
  With TRegistry.Create Do
  try
    OpenKey(Key, False);
    s:=ReadString(fm.Name+'FormPlacement');
    IF s='' Then
      Exit;
    fm.Top:=StrToInt( GetWord(s,1,[' ']) );
    fm.Left:=StrToInt( GetWord(s,2,[' ']) );
    fm.Height:=StrToInt( GetWord(s,3,[' ']) );
    fm.Width:=StrToInt( GetWord(s,4,[' ']) );
  finally
    Free;
  end;
End;

procedure WriteFormPlacement(fm: TForm; Key: String);
Begin
  With TRegistry.Create Do
  try
    OpenKey(Key, True);
    WriteString(fm.Name+'FormPlacement',
      IntToStr(fm.Top)+' '+IntToStr(fm.Left)+
      ' '+IntToStr(fm.Height)+' '+IntToStr(fm.Width));
  finally
    Free;
  end;
End;

procedure ReadFormPosition(fm: TForm; Key: String);
var
  s: String;
Begin
  With TRegistry.Create Do
  try
    OpenKey(Key, False);
    s:=ReadString(fm.Name+'FormPlacement');
    IF s='' Then
      Exit;
    fm.Top:=StrToInt( GetWord(s,1,[' ']) );
    fm.Left:=StrToInt( GetWord(s,2,[' ']) );
  finally
    Free;
  end;
End;

procedure WriteFormPosition(fm: TForm; Key: String);
Begin
  With TRegistry.Create Do
  try
    OpenKey(Key, True);
    WriteString(fm.Name+'FormPlacement',
      IntToStr(fm.Top)+' '+IntToStr(fm.Left));
  finally
    Free;
  end;
End;

// ,       
procedure edKeyChar(chKey: Char; ed: TEdit);
var
  iCur: Integer;
Begin
  Case chKey OF
    #8:
    begin
      IF ed.SelLength>0 Then
        edKeyChar(' ', ed);
      iCur:=ed.SelStart;
      ed.Text:=Copy(ed.Text, 0, iCur-1)+
        Copy(ed.Text, iCur+1, Length(ed.Text));
      ed.SelStart:=iCur-1;
    end;
    Else
    begin
      iCur:=ed.SelStart;
      ed.Text:=Copy(ed.Text, 0, iCur)+chKey+
        Copy(ed.Text, iCur+ed.SelLength+Length(chKey), Length(ed.Text)-iCur);
      ed.SelStart:=iCur+Length(chKey);
      ed.SelLength:=0;
    end;
  End;//Case
end;

procedure cbKeyChar(chKey: Char; cb: TComboBox);
var
  iCur: Integer;
Begin
  Case chKey OF
    #8:
    begin
      IF cb.SelLength>0 Then
        cbKeyChar(' ', cb);
      iCur:=cb.SelStart;
      cb.Text:=Copy(cb.Text, 0, iCur-1)+
        Copy(cb.Text, iCur+1, Length(cb.Text));
      cb.SelStart:=iCur-1;
    end;
    Else
    begin
      iCur:=cb.SelStart;
      cb.Text:=Copy(cb.Text, 0, iCur)+chKey+
        Copy(cb.Text, iCur+cb.SelLength+Length(chKey), Length(cb.Text)-iCur);
      cb.SelStart:=iCur+Length(chKey);
      cb.SelLength:=0;
    end;
  End;//Case
end;

procedure WriteList(Reg: TRegistry; Ident: String; ls: TStrings);
var
  i,j: Integer;
Begin
  j:=0;
  For i:=0 To ls.Count-1 Do
    IF ls[i]<>'' Then
    begin
      Reg.WriteString(Ident+IntToStr(j), ls[i]);
      Inc(j);
    end;
  Reg.WriteString(Ident+IntToStr(j), '');
End;

procedure ReadList(Reg: TRegistry; Ident: String; ls: TStrings);
var
  i: Integer;
  s: String;
Begin
  i:=0;  ls.Clear;
  Repeat
    s:=Reg.ReadString(Ident+IntToStr(i));
    ls.Add(s);
    Inc(i);
  Until s='';
  ls.Delete(ls.Count-1);
End;

end.
